%global namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}
%global with_test 0
Name:          deltaspike
Version:       1.2.1
Release:       2%{?dist}
Summary:       Portable CDI extensions
License:       ASL 2.0
URL:           http://deltaspike.apache.org/
Source0:       https://github.com/apache/deltaspike/archive/%{name}-project-%{namedversion}.tar.gz
# support for servlet 3.0 apis
#Patch0:        %%{name}-0.5-cdictrl-impl-owb-servlet30.patch

BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jcdi_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-validation_1.0_spec)
# TODO update to 1.2.7
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans-impl)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans-resource)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans-spi)

BuildRequires: mvn(org.apache.tomcat:tomcat-servlet-api)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.0-api)
BuildRequires: mvn(org.jboss.spec.javax.el:jboss-el-api_2.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.1_spec)
BuildRequires: mvn(org.jboss.spec.javax.servlet:jboss-servlet-api_2.5_spec)
BuildRequires: mvn(org.jboss.arquillian.container:arquillian-container-test-spi)
BuildRequires: mvn(org.jboss.shrinkwrap:shrinkwrap-api)
BuildRequires: mvn(org.jboss.weld.se:weld-se-core)
BuildRequires: mvn(org.quartz-scheduler:quartz)

%if %with_test
# Test deps
BuildRequires: mvn(asm:asm-commons)
BuildRequires: mvn(javassist:javassist)
BuildRequires: mvn(org.apache.bval:bval-jsr303)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-osgi-locator)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.openwebbeans.arquillian:owb-arquillian-standalone)
BuildRequires: mvn(org.apache.xbean:xbean-finder)
BuildRequires: mvn(org.hamcrest:hamcrest-library)
BuildRequires: mvn(org.jboss.arquillian.junit:arquillian-junit-container)
BuildRequires: mvn(org.jboss.as:jboss-as-arquillian-container-remote)
BuildRequires: mvn(org.jboss.shrinkwrap.descriptors:shrinkwrap-descriptors-impl)
BuildRequires: mvn(org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-impl-maven)
BuildRequires: mvn(org.apache.myfaces.test:myfaces-test20)
BuildRequires: mvn(org.apache.myfaces.core:myfaces-impl-test)

BuildRequires: mvn(org.bsc.maven:maven-processor-plugin)
BuildRequires: mvn(org.hibernate:hibernate-jpamodelgen)

# TODO http://gil.fedorapeople.org/resources-optimizer-maven-plugin-1.1.0-1.fc20.src.rpm
BuildRequires: mvn(org.primefaces.extensions:resources-optimizer-maven-plugin)
%endif

BuildRequires: maven-local
BuildRequires: maven-antrun-plugin
BuildRequires: maven-remote-resources-plugin
BuildRequires: maven-site-plugin
# site plugin runtime deps
BuildRequires: mvn(org.apache.maven.doxia:doxia-integration-tools)
%if %{?fedora} > 20
BuildRequires: mvn(org.apache.geronimo.specs:specs:pom:)
BuildRequires: mvn(org.apache.maven.shared:maven-shared-components:pom:)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans:pom:)
#BuildRequires: mvn(org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-bom:pom:)
%else
BuildRequires: mvn(org.apache.geronimo.specs:specs)
BuildRequires: mvn(org.apache.maven.shared:maven-shared-components)
BuildRequires: mvn(org.apache.openwebbeans:openwebbeans)
#BuildRequires: mvn(org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-bom)
%endif
BuildArch:     noarch

%description
DeltaSpike consist of a number of portable CDI extensions
that provide useful features for Java application developers.

%package core
Summary:       Apache DeltaSpike Core

%description core
Apache DeltaSpike Core APIs and Implementation.

%package cdictrl
Summary:       Apache DeltaSpike ContainerControl

%description cdictrl
This project provides a way to generically run CDI containers 
from inside of unit tests or Java SE applications.

%package modules
Summary:       Apache DeltaSpike Modules

%description modules
Apache DeltaSpike Modules Parent Pom.

%package bean-validation-module
Summary:       Apache DeltaSpike BeanValidation-Module

%description bean-validation-module
Apache DeltaSpike BeanValidation-Module APIs and implementations.

%package data-module
Summary:       Apache DeltaSpike Data-Module

%description data-module
Apache DeltaSpike Data-Module APIs and implementations.

%package jpa-module
Summary:       Apache DeltaSpike JPA-Module

%description jpa-module
Apache DeltaSpike JPA-Module APIs and implementations.

%package jsf-module
Summary:       Apache DeltaSpike JSF-Module

%description jsf-module
Apache DeltaSpike JSF-Module APIs and implementations.

%package partial-bean-module
Summary:       Apache DeltaSpike Partial-Bean-Module

%description partial-bean-module
Apache DeltaSpike Partial-Bean-Module APIs and implementations.

%package scheduler-module
Summary:       Apache DeltaSpike Scheduler-Module

%description scheduler-module
Apache DeltaSpike Scheduler-Module APIs and implementations.

%package security-module
Summary:       Apache DeltaSpike Security-Module

%description security-module
Apache DeltaSpike Security-Module APIs and implementations.

%package servlet-module
Summary:       Apache DeltaSpike Servlet-Module

%description servlet-module
Apache DeltaSpike Servlet-Module APIs and implementations.

%package test-control-module
Summary:       Apache DeltaSpike Test-Control-Module

%description test-control-module
Apache DeltaSpike Test-Control-Module APIs and implementations.

%package test-utils
Summary:       Apache DeltaSpike Test-Utils

%description test-utils
This package contains our Test Categories and
other useful stuff for running our tests.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{name}-project-%{namedversion}
# cleanup
find . -name "*.class" -print -delete
find . -name "*.jar" -print -delete
mv %{name}/* .
rm -r %{name}

#%% patch0 -p0

%pom_disable_module checkstyle-rules
%pom_disable_module examples

# org.apache.openejb:openejb-core 4.0.0-beta-2
%pom_disable_module impl-openejb cdictrl
# package org.apache.myfaces.test.mock does not exist
# package org.apache.myfaces.mc.test.core.runner
%pom_disable_module impl modules/test-control


%pom_remove_plugin :maven-checkstyle-plugin parent

%pom_remove_plugin :maven-dependency-plugin parent
%pom_remove_plugin :maven-dependency-plugin parent/code
%pom_remove_plugin :maven-dependency-plugin cdictrl/impl-openejb
%pom_remove_plugin :maven-dependency-plugin cdictrl/impl-weld
%pom_remove_plugin :maven-dependency-plugin cdictrl/impl-owb

%pom_remove_plugin :maven-source-plugin parent
%pom_remove_plugin :maven-source-plugin parent/code
%pom_remove_plugin :maven-source-plugin modules/jpa/api
%pom_remove_plugin :maven-source-plugin modules/jpa/impl
%pom_remove_plugin :maven-source-plugin modules/partial-bean/api
%pom_remove_plugin :maven-source-plugin modules/security/api
%pom_remove_plugin :maven-source-plugin modules/scheduler/api
%pom_remove_plugin :maven-source-plugin modules/scheduler/impl
%pom_remove_plugin :maven-source-plugin modules/test-control/api
%pom_remove_plugin :maven-source-plugin modules/test-control/impl
%pom_remove_plugin :maven-processor-plugin modules/data/impl

# Non-resolvable import POM used by arquillian-bom
%pom_remove_dep org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-bom modules/data
%pom_remove_dep org.jboss.arquillian:arquillian-bom parent
%pom_remove_dep org.jboss.arquillian:arquillian-bom parent/code

%pom_remove_dep org.apache.geronimo.specs:geronimo-interceptor_1.1_spec parent/code
%pom_add_dep org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.1_spec parent/code
%pom_remove_dep org.apache.geronimo.specs:geronimo-atinject_1.0_spec parent/code
%pom_add_dep javax.inject:javax.inject parent/code

%pom_remove_dep org.apache.geronimo.specs:geronimo-interceptor_1.1_spec cdictrl/impl-owb
%pom_add_dep org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.1_spec::provided cdictrl/impl-owb
%pom_remove_dep org.apache.geronimo.specs:geronimo-atinject_1.0_spec cdictrl/impl-owb
%pom_add_dep javax.inject:javax.inject::provided cdictrl/impl-owb
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_2.5_spec cdictrl/impl-owb
#%% pom_add_dep org.apache.tomcat:tomcat-servlet-api::provided cdictrl/impl-owb
%pom_add_dep org.jboss.spec.javax.servlet:jboss-servlet-api_2.5_spec::provided cdictrl/impl-owb

%pom_remove_dep org.apache.geronimo.specs:geronimo-atinject_1.0_spec cdictrl/api
%pom_add_dep javax.inject:javax.inject cdictrl/api
%pom_remove_dep org.apache.geronimo.specs:geronimo-interceptor_1.1_spec cdictrl/api
%pom_add_dep org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.1_spec cdictrl/api

%pom_remove_dep org.apache.geronimo.specs:geronimo-atinject_1.0_spec cdictrl/tck
%pom_add_dep javax.inject:javax.inject::provided cdictrl/tck
%pom_remove_dep org.apache.geronimo.specs:geronimo-interceptor_1.1_spec cdictrl/tck
%pom_add_dep org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.1_spec::provided cdictrl/tck


%pom_remove_dep org.apache.geronimo.specs:geronimo-jpa_2.0_spec modules/data/api
%pom_add_dep org.hibernate.javax.persistence:hibernate-jpa-2.0-api modules/data/api

%pom_remove_dep org.apache.geronimo.specs:geronimo-jpa_2.0_spec modules/data/impl
%pom_add_dep org.hibernate.javax.persistence:hibernate-jpa-2.0-api modules/data/impl

%pom_remove_dep org.apache.geronimo.specs:geronimo-jpa_2.0_spec modules/jpa
%pom_add_dep org.hibernate.javax.persistence:hibernate-jpa-2.0-api modules/jpa

# TODO
%pom_remove_plugin :resources-optimizer-maven-plugin modules/jsf/impl
%pom_remove_plugin :resources-optimizer-maven-plugin modules/jsf/impl-ee6

%pom_remove_dep org.apache.myfaces.core:myfaces-api modules/jsf
%pom_add_dep org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec modules/jsf
%pom_remove_dep org.apache.myfaces.core:myfaces-api modules/jsf/api
%pom_add_dep org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec modules/jsf/api
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_2.5_spec modules/jsf/api
%pom_add_dep org.apache.tomcat:tomcat-servlet-api modules/jsf/api
%pom_remove_dep org.apache.geronimo.specs:geronimo-el_2.2_spec modules/jsf/impl
%pom_add_dep org.jboss.spec.javax.el:jboss-el-api_2.2_spec::provided modules/jsf/impl
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_3.0_spec modules/jsf/impl
%pom_add_dep org.apache.tomcat:tomcat-servlet-api modules/jsf/impl
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_3.0_spec modules/jsf/impl-ee6
%pom_add_dep org.apache.tomcat:tomcat-servlet-api modules/jsf/impl-ee6
%pom_remove_dep org.apache.geronimo.specs:geronimo-el_2.2_spec modules/jsf/impl-ee6
%pom_add_dep org.jboss.spec.javax.el:jboss-el-api_2.2_spec::provided modules/jsf/impl-ee6

%if 0
%pom_remove_dep org.apache.geronimo.specs:geronimo-jpa_2.0_spec modules/test-control/impl
%pom_add_dep org.hibernate.javax.persistence:hibernate-jpa-2.0-api::provided modules/test-control/impl
%pom_remove_dep org.apache.myfaces.core:myfaces-api modules/test-control/impl
%pom_remove_dep org.apache.myfaces.core:myfaces-impl modules/test-control/impl
%pom_add_dep org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec modules/test-control/impl
%pom_remove_dep org.apache.geronimo.specs:geronimo-el_2.2_spec modules/test-control/impl
%pom_add_dep org.jboss.spec.javax.el:jboss-el-api_2.2_spec::provided modules/test-control/impl
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_2.5_spec modules/test-control/impl
%pom_add_dep org.apache.tomcat:tomcat-servlet-api::provided modules/test-control/impl
%endif


%pom_remove_dep org.apache.geronimo.specs:geronimo-jpa_2.0_spec modules/security/impl
%pom_add_dep org.hibernate.javax.persistence:hibernate-jpa-2.0-api modules/security/impl

sed -i "s|<groupId>org.apache.geronimo.specs|<groupId>org.apache.tomcat|" modules/servlet/pom.xml
sed -i "s|<artifactId>geronimo-servlet_2.5_spec|<artifactId>tomcat-servlet-api|" modules/servlet/pom.xml
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_2.5_spec modules/servlet/api
%pom_add_dep org.apache.tomcat:tomcat-servlet-api::provided modules/servlet/api
%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_2.5_spec modules/servlet/impl
%pom_add_dep org.apache.tomcat:tomcat-servlet-api::provided modules/servlet/impl

%pom_remove_dep org.apache.geronimo.specs:geronimo-servlet_3.0_spec cdictrl/servlet
%pom_remove_dep org.apache.geronimo.specs:geronimo-atinject_1.0_spec  cdictrl/servlet
%pom_remove_dep org.apache.geronimo.specs:geronimo-interceptor_1.1_spec cdictrl/servlet
%pom_add_dep org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.1_spec cdictrl/servlet
%pom_add_dep org.apache.tomcat:tomcat-servlet-api cdictrl/servlet
%pom_add_dep javax.inject:javax.inject cdictrl/servlet


%mvn_package ":%{name}-project" %{name}
%mvn_package ":parent*" %{name}
%mvn_package ":*core*" core
# unavailable deps for: impl-openejb impl-owb impl-weld
%mvn_package ":*cdictrl*" cdictrl
%mvn_package ":modules-project" modules
%mvn_package ":*bean-validation*" bean-validation-module
%mvn_package ":*data*" data-module
%mvn_package ":*jpa*" jpa-module
%mvn_package ":*jsf*" jsf-module
%mvn_package ":*partial*" partial-bean-module
%mvn_package ":*scheduler*" scheduler-module
%mvn_package ":*security*" security-module
%mvn_package ":*servlet*" servlet-module
%mvn_package ":*test-control*" test-control-module
%mvn_package ":test-utils" test-utils

%build

# No test deps
%mvn_build \
%if !%with_test
 -f
%endif

%install
%mvn_install

%if %with_test
install -m 644 core/api/target/%{name}-core-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-core-api-tests.jar
install -m 644 core/impl/target/%{name}-core-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-core-impl-tests.jar
install -m 644 modules/bean-validation/api/target/%{name}-bean-validation-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-bean-validation-module-api-tests.jar
install -m 644 modules/bean-validation/impl/target/%{name}-bean-validation-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-bean-validation-module-impl-tests.jar
install -m 644 modules/data/api/target/%{name}-data-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-data-module-api-tests.jar
install -m 644 modules/data/impl/target/%{name}-data-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-data-module-impl-tests.jar
install -m 644 modules/jpa/api/target/%{name}-jpa-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-jpa-module-api-tests.jar
install -m 644 modules/jpa/impl/target/%{name}-jpa-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-jpa-module-impl-tests.jar
install -m 644 modules/jsf/api/target/%{name}-jsf-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-jsf-module-api-tests.jar
install -m 644 modules/jsf/impl/target/%{name}-jsf-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-jsf-module-impl-tests.jar
install -m 644 modules/partial-bean/api/target/%{name}-partial-bean-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-partial-bean-module-api-tests.jar
install -m 644 modules/partial-bean/impl/target/%{name}-partial-bean-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-partial-bean-module-impl-tests.jar
install -m 644 modules/security/api/target/%{name}-security-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-security-module-api-tests.jar
install -m 644 modules/security/impl/target/%{name}-security-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-security-module-impl-tests.jar
install -m 644 modules/servlet/api/target/%{name}-servlet-module-api-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-servlet-module-api-tests.jar
install -m 644 modules/servlet/impl/target/%{name}-servlet-module-impl-%{namedversion}-tests.jar %{buildroot}%{_javadir}/%{name}/%{name}-servlet-module-impl-tests.jar
%endif

%files -f .mfiles-%{name}
%dir %{_javadir}/%{name}
%doc README.md readme/*-%{namedversion}.txt
%license LICENSE NOTICE

%files core -f .mfiles-core
%license LICENSE NOTICE

%files cdictrl -f .mfiles-cdictrl
%license LICENSE NOTICE

%files modules -f .mfiles-modules
%license LICENSE NOTICE

%files bean-validation-module -f .mfiles-bean-validation-module
%license LICENSE NOTICE

%files data-module -f .mfiles-data-module
%doc modules/data/README.adoc
%license LICENSE NOTICE

%files jpa-module -f .mfiles-jpa-module
%license LICENSE NOTICE

%files jsf-module -f .mfiles-jsf-module
%license LICENSE NOTICE

%files partial-bean-module -f .mfiles-partial-bean-module
%license LICENSE NOTICE

%files scheduler-module -f .mfiles-scheduler-module
%license LICENSE NOTICE

%files security-module -f .mfiles-security-module
%license LICENSE NOTICE

%files servlet-module -f .mfiles-servlet-module
%license LICENSE NOTICE

%files test-control-module -f .mfiles-test-control-module
%license LICENSE NOTICE

%files test-utils -f .mfiles-test-utils
%if %with_test
%{_javadir}/%{name}/%{name}-*-tests.jar
%endif
%license LICENSE NOTICE

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Mon Feb 16 2015 gil cattaneo <puntogil@libero.it> 1.2.1-2
- resolve Non-resolvable import POM

* Mon Feb 02 2015 gil cattaneo <puntogil@libero.it> 1.2.1-1
- update to 1.2.1

* Mon Sep 30 2013 gil cattaneo <puntogil@libero.it> 0.5-1
- update to 0.5

* Fri Jun 14 2013 gil cattaneo <puntogil@libero.it> 0.4-1
- update to 0.4

* Sat May 25 2013 gil cattaneo <puntogil@libero.it> 0.3-1
- initial rpm
